package be.cylab.java.wowa.training;

import info.debatty.java.aggregation.WOWA;

public class SolutionDistance {

    private double[] weights_w;
    private double[] weights_p;
    private double distance = Double.POSITIVE_INFINITY;

    public void computeScoreTo(double[][] data, double[] expected) {
        this.distance = 0;
        for (int i = 0; i < data.length; i++) {
            double[] vector = data[i];
            double target_value = expected[i];
            WOWA wowa = new WOWA(this.weights_w, this.weights_p);
            double aggregated_value = wowa.aggregates(vector);
            this.distance += Math.pow(target_value - aggregated_value, 2);
        }
        this.distance = Math.sqrt(this.distance);

    }

    public void randomlyMutateWithProbability(double probability) {

    }

    public void normalize() {

    }

    public static void sort(SolutionDistance[]) {

    }

    public double[] getWeights_w() {
        return weights_w;
    }

    public double[] getWeights_p() {
        return weights_p;
    }

    public double getDistance() {
        return distance;
    }
}
